(require-library "functio.ss")

; partial-sum : (listof number) number -> (listof number)
(define (partial-sum L accum)
  (cond
    [(null? L) '()]
    [else (let ([new-accum (+ (car L) accum)])
            (cons new-accum (partial-sum (cdr L) new-accum)))]))

; rand-LL : (listof (listof 'a)) number -> (listof number)
(define (rand-LL LL n)
  ;;(display "LL=")
  ;;(display LL)
  ;;(newline)
  (cond
    [(null? LL) '()]
    [else (let* ([L (map (compose (lambda (x) (/ 1 (+ x .1))) length) LL)]
                 [sum (apply + L)]
                 [L2 (map (lambda (x) (* n (/ x sum))) L)])
            (partial-sum L2 0))]))

; (rand-LL '((a b c) (d e) (f g h i) (j)) 100)