;;Different search strategies:
;; 1) The linear random search: looks randomly for a complete
;;    answer every time.  Updates the best so far.
;;    This thread will run forever.


(define (search meaning-vec)
  (linear-random meaning-vec (make-answer-space (vector-length meaning-vec))))

;(define (search meaning-vec)
;  (display "in search")
;  (newline)
;  (wait-on-threads (list
;                    (run-thread linear-random meaning-vec))))
                    

; (define (run-thread search-func meaning-vec)
;   (thread (lambda () (search-func meaning-vec 
;                                   (make-answer-space 
;                                    (vector-length meaning-vec))))))

; (define (wait-on-threads ls)
;   (cond
;     ((empty? ls) 'done)
;     (else
;      (sleep 3)  ;;might want to make the wait time different
;      (wait-on-threads (filter-dead-threads ls)))))

(define (filter-dead-threads ls)
  (filter thread-running? ls))

(define (rob-cost vec dummy-arg)
  ;;(display "inside rob cost")
  ;;(newline)
  (let ((ccc (rob-cost-help vec 0 (vector-length vec) 0)))
    ;(display "cost is ")
    ;(display ccc)
    ;(newline)
    ;(if (= ccc 0)
;	(begin (display vec) (newline) (error "hih")))
    ccc))

(define (rob-cost-help vec pos len sum)
  (cond
    ((= pos len) sum)
    (else (rob-cost-help vec (+ 1 pos) len
			 (+ sum (indiv-weight (cdr (vector-ref vec pos))))))))

(define (indiv-weight tag-ls)
  (foldl (lambda (x y)
           (+ (symb->weight x) y))
         0
         tag-ls))

(define (symb->weight x)
  (if
   (or (eq? x 'EM)
       (eq? x 'PL)
       (eq? x 'TT))
   9
   7))

