(load-relative "randrob.ss")
;;Searching Algorithms

;; linear-random
(define (linear-random meaning-vec answer-space)
  (full-simple-search! meaning-vec smart-random-select answer-space)
  (update-if-better answer-space (rob-cost answer-space
                                           (vector-length answer-space)))
  (linear-random meaning-vec answer-space))


(define (smart-random-select tags)
  (distrib-select
   (rand-LL (map (lambda (t)
                  (cdar t))
                 tags)
            100)
   tags
   (random 100)))

(define (distrib-select list-distrib tags r)
  ;(display "list-distrib is ")
  ;(display list-distrib)
  ;(newline)
  (cond
    ((< r (first list-distrib)) (first tags))
    (else (distrib-select (rest list-distrib) (rest tags) r))))
  

;;test tag-selection-functions go here
(define (random-select tags)
  (list-ref tags (random (length tags))))